-- These functions make the scry cards much shorter, and allow me to make slight fixes if needed

COMPARTMENT_ID_SCRY_COUNT = 4444
COMPARTMENT_ID_SCRY_TARGETS = 4445

Scry_ResolutionTimeAction1 = function(how_much, targets_base)
-- use this as the first RESOLUTION_TIME_ACTION of the scry mechanic
	if how_much == nil then
		EffectDC():Set_Int(COMPARTMENT_ID_SCRY_COUNT, 3)
	else
		EffectDC():Set_Int(COMPARTMENT_ID_SCRY_COUNT, how_much)
	end
	if target_base == nil then
		EffectDC():Set_Int(COMPARTMENT_ID_SCRY_TARGETS, 0)
	else
		EffectDC():Set_Int(COMPARTMENT_ID_SCRY_TARGETS, targets_base)
	end
	local filter = Object():GetFilter()
	local player = EffectController()
	filter:Clear()
	filter:NotTargetted()
	filter:SetPlayer( player )
	filter:SetZone( ZONE_LIBRARY )
	filter:SetPortion( how_much )
	player:SetTargetCount( how_much )
	for i=0,how_much-1 do
		player:SetTargetPrompt( i, "CARD_QUERY_CHOOSE_CARD_TO_PUT_ON_BOTTOM_LIBRARY" )
	end
	player:ChooseTargetsWithFlags( NO_VALIDATION, EffectDC():Make_Targets( EffectDC():Get_Int(COMPARTMENT_ID_SCRY_TARGETS) ), QUERY_FLAG_CAN_BE_FINISHED_EARLY + QUERY_FLAG_CAN_BE_FINISHED_EARLY_FOR_AI_AS_WELL )
end

Scry_ResolutionTimeAction2 = function()
-- use this as the second RESOLUTION_TIME_ACTION of the scry mechanic
	local target_array = {}
	local count = EffectDC():Get_Int(COMPARTMENT_ID_SCRY_COUNT)
	for i=0,count-1 do
		target_array[i] = EffectDC():Get_Targets( EffectDC():Get_Int(COMPARTMENT_ID_SCRY_TARGETS) ):Get_CardPtr(i)
	end
	for i=0,count-1 do
		if target_array[i] ~= nil then
			target_array[i]:PutInLibrary(-1)
			count = count-1
		end
	end
	EffectDC():Set_Int(COMPARTMENT_ID_SCRY_COUNT, count)
	EffectDC():Int_Inc(COMPARTMENT_ID_SCRY_TARGETS)
end

Scry_ResolutionTimeAction3 = function()
-- use this as the third RESOLUTION_TIME_ACTION of the scry mechanic
	local count = EffectDC():Get_Int(COMPARTMENT_ID_SCRY_COUNT)
	if count > 0 then
		local filter = Object():GetFilter()
		local player = EffectController()
		filter:Clear()
		filter:NotTargetted()
		filter:SetPortion( count )
		filter:SetPlayer( player )
		filter:SetZone( ZONE_LIBRARY )
		player:SetTargetCount( count )
		while count > 0 do
			count = count - 1
			player:SetTargetPrompt( count, "CARD_QUERY_CHOOSE_CARD_TO_PUT_ONTO_LIBRARY" )
		end
		player:ChooseTargetsWithFlags( NO_VALIDATION, EffectDC():Make_Targets( EffectDC():Get_Int(COMPARTMENT_ID_SCRY_TARGETS) ), 0 )
	end
end

Scry_ResolutionTimeAction4 = function()
-- use this as the fourth (and last) RESOLUTION_TIME_ACTION of the scry mechanic
	local i = 0
	local count = EffectDC():Get_Int(COMPARTMENT_ID_SCRY_COUNT)
	local targetDC = EffectDC():Get_Targets( EffectDC():Get_Int(COMPARTMENT_ID_SCRY_TARGETS) )
	if targetDC ~= nil then
		while targetDC:Get_CardPtr(i) ~= nil do
			targetDC:Get_CardPtr(i):PutInLibrary( count - (i+1) )
			targetDC:Set_CardPtr(i, nil)
			i = i+1
		end
	end
end